/* modified preselect-lock.p. */

package com.goldencode.testcases;

import com.goldencode.p2j.util.*;
import com.goldencode.testcases.ui.*;
import com.goldencode.p2j.ui.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.testcases.dmo._temp.*;
import com.goldencode.testcases.dmo.p2j_test.*;
import com.goldencode.p2j.persist.lock.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.MathOps.*;
import static com.goldencode.p2j.util.CompareOps.*;
import static com.goldencode.p2j.util.KeyReader.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.util.TextOps.*;
import static com.goldencode.p2j.ui.LogicalTerminal.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in test_denormalization.p).
 */
public class TestDenormalization
{
   TempRecord1.Buf tt = TemporaryBuffer.define(TempRecord1.Buf.class, "tt", "tt", false);

   Person.Buf xPerson = RecordBuffer.define(Person.Buf.class, "p2j_test", "xPerson", "x-person");

   Person.Buf person = RecordBuffer.define(Person.Buf.class, "p2j_test", "person", "person");

   TestDenormalizationFrame0 frame0 = GenericFrame.createFrame(TestDenormalizationFrame0.class, "");

   final QueryWrapper query0 = new QueryWrapper("q", false);

   integer i = new integer(0);

   /**
    * External procedure (converted to Java from the 4GL source code
    * in test_denormalization.p).
    */
   public void execute()
   {
      externalProcedure(new Block()
      {
         character saved = new character("");

         public void init()
         {
            TransactionManager.register(saved, i);
         }

         public void body()
         {
            frame0.openScope();
            RecordBuffer.openScope(tt, xPerson, person);
            /* Preselect locking testcases. */;
            message("press 1-9 or a-b!");
            KeyReader.readKey();
            i.assign(3);
            
            doBlock(TransactionType.FULL, "blockLabel0", new Block()
            {
               public void body()
               {
                  if (_isEqual(chr(lastKey()), "1"))
                  {
                     new FindQuery(person, "upper(person.schedule[3]) = 'AAA'", null, "person.siteId asc, person.empNum asc").first();
                     
                     FrameElement[] elementList0 = new FrameElement[]
                     {
                        new Element(new FieldReference(person, "empNum"), frame0.widgetEmpNum()),
                        new Element(new FieldReference(person, "firstName"), frame0.widgetFirstName()),
                        new Element(new FieldReference(person, "lastName"), frame0.widgetLastName())
                     };
                     
                     frame0.display(elementList0);
                     
                     pause("lock acquired");
                  }
                  else
                  {
                     if (_isEqual(chr(lastKey()), "2"))
                     {
                        new FindQuery(person, "upper(person.schedule[?]) = 'VVV'", null, "person.siteId asc, person.empNum asc", new Object[]
                        {
                           minus((i), 1)
                        }).first();
                        
                        FrameElement[] elementList1 = new FrameElement[]
                        {
                           new Element(new FieldReference(person, "empNum"), frame0.widgetEmpNum()),
                           new Element(new FieldReference(person, "firstName"), frame0.widgetFirstName()),
                           new Element(new FieldReference(person, "lastName"), frame0.widgetLastName())
                        };
                        
                        frame0.update(elementList1);
                        
                        pause("lock acquired");
                     }
                     else
                     {
                        if (_isEqual(chr(lastKey()), "3"))
                        {
                           doBlock("blockLabel1", new Block()
                           {
                              PreselectQuery query1 = null;

                              public void init()
                              {
                                 query1 = new PreselectQuery(person, (String) null, null, "person.schedule asc, person.siteId asc, person.empNum asc");
                              }

                              public void body()
                              {
                                 query1.last();
                                 pause("lock acquired");
                              }
                           });
                        }
                        else
                        {
                           if (_isEqual(chr(lastKey()), "4"))
                           {
                              doBlock("blockLabel2", new Block()
                              {
                                 PresortQuery query2 = null;

                                 FieldReference byExpr0 = new FieldReference(person, "schedule", minus((plus(i, 1)), 1));

                                 public void init()
                                 {
                                    query2 = new PresortQuery(person, (String) null, null, "person.schedule asc, person.siteId asc, person.empNum asc", LockType.EXCLUSIVE);
                                    query2.addSortCriterion(byExpr0);
                                 }

                                 public void body()
                                 {
                                    query2.last();
                                    pause("lock acquired");
                                 }
                              });
                           }
                           else
                           {
                              if (_isEqual(chr(lastKey()), "5"))
                              {
                                 query0.assign(new PreselectQuery(person, (String) null, null, "person.empNum asc, person.siteId asc", LockType.EXCLUSIVE));
                                 query0.open();
                                 query0.first();
                                 message(valueOf((integer) new FieldReference(person, "empNum").getValue()));
                                 query0.last();
                                 message(valueOf((integer) new FieldReference(person, "empNum").getValue()));
                                 pause("lock acquired");
                                 new FindQuery(person, (String) null, null, "person.siteId asc, person.empNum asc", LockType.EXCLUSIVE).first();
                                 message(valueOf((integer) new FieldReference(person, "empNum").getValue()));
                                 new FindQuery(person, (String) null, null, "person.siteId asc, person.empNum asc", LockType.EXCLUSIVE).next();
                              }
                              else
                              {
                                 if (_isEqual(chr(lastKey()), "6"))
                                 {
                                    repeat("loopLabel0", new Block()
                                    {
                                       PreselectQuery query3 = null;

                                       public void init()
                                       {
                                          query3 = new PreselectQuery(person, (String) null, null, "person.empNum asc, person.siteId asc", LockType.NONE);
                                       }

                                       public void body()
                                       {
                                          query3.first();
                                          message(valueOf((integer) new FieldReference(person, "empNum").getValue()));
                                          query3.last();
                                          message(valueOf((integer) new FieldReference(person, "empNum").getValue()));
                                          pause("lock acquired");
                                       }
                                    });
                                    
                                    new FindQuery(person, (String) null, null, "person.siteId asc, person.empNum asc", LockType.EXCLUSIVE).first();
                                 }
                                 else
                                 {
                                    if (_isEqual(chr(lastKey()), "7"))
                                    {
                                       doBlock("blockLabel3", new Block()
                                       {
                                          PreselectQuery query4 = null;

                                          public void init()
                                          {
                                             query4 = new PreselectQuery(person, (String) null, null, "person.empNum desc, person.siteId asc");
                                          }

                                          public void body()
                                          {
                                             query4.first();
                                             pause("lock1 acquired");
                                             new FindQuery(xPerson, "xPerson.empNum = 123", null, "xPerson.siteId asc, xPerson.empNum asc", LockType.NONE).first();
                                             pause("lock2 acquired");
                                          }
                                       });
                                    }
                                    else
                                    {
                                       if (_isEqual(chr(lastKey()), "8"))
                                       {
                                          new FindQuery(person, "person.empNum = 123", null, "person.siteId asc, person.empNum asc").first();
                                          pause("lock1 acquired");
                                          new FindQuery(xPerson, "xPerson.empNum = 123", null, "xPerson.siteId asc, xPerson.empNum asc", LockType.NONE).first();
                                          pause("lock2 acquired");
                                       }
                                       else
                                       {
                                          if (_isEqual(chr(lastKey()), "9"))
                                          {
                                             doBlock("blockLabel4", new Block()
                                             {
                                                PreselectQuery query5 = null;

                                                public void init()
                                                {
                                                   query5 = new PreselectQuery(person, (String) null, null, "person.empNum asc, person.siteId asc", LockType.EXCLUSIVE);
                                                }

                                                public void body()
                                                {
                                                   query5.last();
                                                   pause("lock1 acquired");
                                                }
                                             });
                                             
                                             new FindQuery(person, (String) null, null, "person.siteId asc, person.empNum asc", LockType.SHARE).first();
                                             pause("lock2 acquired");
                                          }
                                          else
                                          {
                                             if (_isEqual(chr(lastKey()), "a"))
                                             {
                                                doBlock("blockLabel5", new Block()
                                                {
                                                   PreselectQuery query6 = null;

                                                   public void init()
                                                   {
                                                      query6 = new PreselectQuery(person, (String) null, null, "person.empNum asc, person.siteId asc", LockType.SHARE);
                                                   }

                                                   public void body()
                                                   {
                                                      query6.last();
                                                      pause("lock1 acquired");
                                                      
                                                      doBlock("blockLabel6", new Block()
                                                      {
                                                         PreselectQuery query7 = null;

                                                         public void init()
                                                         {
                                                            query7 = new PreselectQuery(xPerson, (String) null, null, "xPerson.empNum asc, xPerson.siteId asc", LockType.EXCLUSIVE);
                                                         }

                                                         public void body()
                                                         {
                                                            query7.last();
                                                            pause("lock2 acquired");
                                                         }
                                                      });
                                                   }
                                                });
                                             }
                                             else
                                             {
                                                saved.assign(chr(lastKey()));
                                             }
                                          }
                                       }
                                    }
                                 }
                              }
                           }
                        }
                     }
                  }
                  pause("after cycle");
               }
            });
            
            if (_isEqual(saved, "b"))
            {
               doBlock(TransactionType.FULL, "blockLabel7", new Block()
               {
                  public void body()
                  {
                     doBlock("blockLabel8", new Block()
                     {
                        PreselectQuery query8 = null;

                        public void init()
                        {
                           query8 = new PreselectQuery(person, (String) null, null, "person.empNum asc, person.siteId asc", LockType.SHARE);
                        }

                        public void body()
                        {
                           query8.last();
                           pause("lock1 acquired");
                        }
                     });
                  }
               });
               
               pause("lock2 acquired");
               
               doBlock(TransactionType.FULL, "blockLabel9", new Block()
               {
                  public void body()
                  {
                     doBlock("blockLabel10", new Block()
                     {
                        PreselectQuery query9 = null;

                        public void init()
                        {
                           query9 = new PreselectQuery(person, (String) null, null, "person.empNum asc, person.siteId asc", LockType.SHARE);
                        }

                        public void body()
                        {
                           query9.last();
                           pause("lock3 acquired");
                        }
                     });
                  }
               });
            }
            pause("end of test");
         }
      });
   }
}
