/* modified preselect-query-test.p. */

package com.goldencode.testcases;

import com.goldencode.p2j.util.*;
import com.goldencode.p2j.persist.*;
import com.goldencode.testcases.dmo._temp.*;
import com.goldencode.testcases.dmo.p2j_test.*;
import com.goldencode.p2j.persist.lock.*;

import static com.goldencode.p2j.util.BlockManager.*;
import static com.goldencode.p2j.util.character.*;
import static com.goldencode.p2j.util.TextOps.*;

/**
 * Business logic (converted to Java from the 4GL source code
 * in test_denormalization.p).
 */
public class TestDenormalization
{
   TempRecord1.Buf tt = TemporaryBuffer.define(TempRecord1.Buf.class, "tt", "tt", false);

   PersAddr.Buf persAddr = RecordBuffer.define(PersAddr.Buf.class, "p2j_test", "persAddr", "pers-addr");

   Person.Buf person = RecordBuffer.define(Person.Buf.class, "p2j_test", "person", "person");

   Customer.Buf customer = RecordBuffer.define(Customer.Buf.class, "p2j_test", "customer", "customer");

   Book.Buf book = RecordBuffer.define(Book.Buf.class, "p2j_test", "book", "book");

   final AdaptiveFind query13 = new AdaptiveFind(persAddr, null, "persAddr.siteId asc, persAddr.empNum asc");

   /**
    * External procedure (converted to Java from the 4GL source code
    * in test_denormalization.p).
    */
   public void execute()
   {
      externalProcedure(TransactionType.FULL, new Block()
      {
         public void body()
         {
            RecordBuffer.openScope(tt, persAddr, person);
            person.create();
            person.setScheduleFourth(new character("wq"));
            person.setSsn(new character("qq"));
            
            doBlock("blockLabel0", new Block()
            {
               PreselectQuery query0 = null;

               public void init()
               {
                  query0 = new PreselectQuery(person, (String) null, null, "person.siteId asc, person.empNum asc");
               }

               public void body()
               {
                  query0.first();
                  
                  loopLabel0:
                  while (person._available())
                  {
                     forEach("loopLabel1", new Block()
                     {
                        AdaptiveQuery query1 = null;

                        public void init()
                        {
                           query1 = new AdaptiveQuery(persAddr, (String) null, null, "persAddr.siteId asc, persAddr.empNum asc");
                        }

                        public void body()
                        {
                           query1.next();
                        }
                     });
                     
                     query0.next();
                  }
               }
            });
            
            doBlock("blockLabel1", new Block()
            {
               PreselectQuery query2 = null;

               public void init()
               {
                  query2 = new PreselectQuery(person, (String) null, null, "person.siteId asc, person.empNum asc");
               }

               public void body()
               {
                  query2.first();
                  
                  loopLabel2:
                  while (person._available())
                  {
                     new FindQuery(persAddr, (String) null, null, "persAddr.siteId asc, persAddr.empNum asc").first();
                     
                     loopLabel3:
                     while (persAddr._available())
                     {
                        query13.next();
                     }
                     
                     query2.next();
                  }
               }
            });
            
            doBlock("blockLabel2", new Block()
            {
               PreselectQuery query3 = null;

               public void init()
               {
                  query3 = new PreselectQuery(person, (String) null, null, "person.siteId asc, person.empNum asc");
               }

               public void body()
               {
                  query3.first();
                  
                  loopLabel4:
                  while (person._available())
                  {
                     forEach("loopLabel5", new Block()
                     {
                        AdaptiveQuery query4 = null;

                        public void init()
                        {
                           query4 = new AdaptiveQuery(persAddr, (String) null, null, "persAddr.siteId asc, persAddr.empNum asc");
                        }

                        public void body()
                        {
                           query4.next();
                           
                           doBlock("blockLabel3", new Block()
                           {
                              PreselectQuery query5 = null;

                              public void init()
                              {
                                 RecordBuffer.openScope(customer);
                                 query5 = new PreselectQuery(customer, (String) null, null, "customer.id asc");
                              }

                              public void body()
                              {
                                 query5.first();
                                 
                                 loopLabel6:
                                 while (customer._available())
                                 {
                                    forEach("loopLabel7", new Block()
                                    {
                                       AdaptiveQuery query6 = null;

                                       public void init()
                                       {
                                          RecordBuffer.openScope(book);
                                          query6 = new AdaptiveQuery(book, (String) null, null, "book.bookId asc");
                                       }

                                       public void body()
                                       {
                                          query6.next();
                                       }
                                    });
                                    
                                    query5.next();
                                 }
                              }
                           });
                        }
                     });
                     
                     query3.next();
                  }
               }
            });
            
            doBlock("blockLabel4", new Block()
            {
               PreselectQuery query7 = null;

               public void init()
               {
                  query7 = new PreselectQuery(person, (String) null, null, "person.siteId asc, person.empNum asc");
               }

               public void body()
               {
                  query7.first();
                  
                  loopLabel8:
                  while (person._available())
                  {
                     new FindQuery(persAddr, (String) null, null, "persAddr.siteId asc, persAddr.empNum asc").first();
                     
                     loopLabel9:
                     while (persAddr._available())
                     {
                        doBlock("blockLabel5", new Block()
                        {
                           PreselectQuery query8 = null;

                           public void init()
                           {
                              RecordBuffer.openScope(customer);
                              query8 = new PreselectQuery(customer, (String) null, null, "customer.id asc");
                           }

                           public void body()
                           {
                              query8.first();
                              
                              loopLabel10:
                              while (customer._available())
                              {
                                 forEach("loopLabel11", new Block()
                                 {
                                    AdaptiveQuery query9 = null;

                                    public void init()
                                    {
                                       RecordBuffer.openScope(book);
                                       query9 = new AdaptiveQuery(book, (String) null, null, "book.bookId asc");
                                    }

                                    public void body()
                                    {
                                       query9.next();
                                    }
                                 });
                                 
                                 query8.next();
                              }
                           }
                        });
                        
                        query13.next();
                     }
                     
                     query7.next();
                  }
               }
            });
            
            doBlock("blockLabel6", new Block()
            {
               PreselectQuery query10 = null;

               public void init()
               {
                  query10 = new PreselectQuery(person, (String) null, null, "person.siteId asc, person.empNum asc");
               }

               public void body()
               {
                  ErrorManager.silentErrorEnable();
                  query10.next();
                  ErrorManager.silentErrorDisable();
                  
                  loopLabel12:
                  while (person._available())
                  {
                     forEach("loopLabel13", new Block()
                     {
                        AdaptiveQuery query11 = null;

                        public void init()
                        {
                           RecordBuffer.prepare(persAddr);
                           query11 = new AdaptiveQuery(persAddr, "upper(persAddr.linkType) = ?", null, "persAddr.linkType asc", new Object[]
                           {
                              toUpperCase(person.getSchedule(2))
                           }, LockType.EXCLUSIVE);
                        }

                        public void body()
                        {
                           query11.next();
                        }
                     });
                     
                     ErrorManager.silentErrorEnable();
                     query10.next();
                     ErrorManager.silentErrorDisable();
                  }
                  
                  ErrorManager.silentErrorEnable();
                  query10.first();
                  ErrorManager.silentErrorDisable();
                  
                  loopLabel14:
                  while (person._available())
                  {
                     forEach("loopLabel15", new Block()
                     {
                        AdaptiveQuery query12 = null;

                        public void init()
                        {
                           RecordBuffer.prepare(persAddr);
                           query12 = new AdaptiveQuery(persAddr, "persAddr.empNum = ?", null, "persAddr.siteId asc, persAddr.empNum asc", new Object[]
                           {
                              person.getEmpNum()
                           }, LockType.EXCLUSIVE);
                        }

                        public void body()
                        {
                           query12.next();
                        }
                     });
                     
                     ErrorManager.silentErrorEnable();
                     query10.next();
                     ErrorManager.silentErrorDisable();
                  }
               }
            });
         }
      });
   }
}
